# /usr/bin/python
# -*- coding: iso-8859-1 -*- 
#
#        BTF
# BacnetTestFramework
#
# Last updated: 30.01.2019
#
# Samplescript
#
# This sample script is provided to give a startpoint
# for development of BTF related scripts.
#
#
# Copyright MBS GmbH
#
#-------------------------------------------------------------------------------
from epilog import *
#-------------------------------------------------------------------------------
class epilog_mbs_9_16_1_3(BasisEpilog):
    scriptname = '''epilog_mbs_9_16_1_3'''
    purpose = ''''''
    configreq = ''''''
    concept = ''''''

    def start(self):

        objType = objType_SN['device']
        instNum = self.bac_handl.rem_inst

        self.gcom.commit(3, {"step":0,"descr":"Starting Epilog"})


        self.gcom.commit(3, {"step":1,"descr":"Delete all new objects"})

        objList = self.global_dict['IUT']['PropertyFeatures'][(objType,instNum,propID_SN['Object_List'])]['Value']
        objList = self.bac_handl.helper.make_list( objList )
        oldObjectList = []
        for entry in objList:
            # convert symbolic-names in EPICS value to numerical values
            if entry[0][0].isdigit():
                oldObjectList.append( ( int(entry[0]), int(entry[1]) ) )
            elif entry[0][0].isalpha():
                oldObjectList.append( ( objType_SN[entry[0]], int(entry[1]) ) )
            else:
                return 1

        objList = str( self.bac_handl.t_read_property( objType, instNum, propID_SN['Object_List'] ) )
        objList = self.bac_handl.helper.make_list( objList )
        newObjectList = []
        for entry in objList:
            # convert symbolic-names in EPICS value to numerical values
            if entry[0][0].isdigit():
                newObjectList.append( ( int(entry[0]), int(entry[1]) ) )
            elif entry[0][0].isalpha():
                newObjectList.append( ( objType_SN[entry[0]], int(entry[1]) ) )
            else:
                return 1



        nCounter = 1
        for newObjType, newInstNum  in newObjectList:
            if (newObjType,newInstNum) not in oldObjectList:
                if not self.global_dict['IUT']['Dynamic'].has_key(newObjType):
                    self.gcom.commit(6,{'description':'%s,%d is no dynamic object in EPICS'%( objType_NS[newObjType],newInstNum ) })
                    continue
                if not self.global_dict['IUT']['Dynamic'][newObjType]['Deleteable']:
                    self.gcom.commit(6,{'description':'%s,%d is not deleteable in EPICS '%( objType_NS[newObjType],newInstNum ) })
                    continue
                self.gcom.commit(3, {"step":1,"substep":nCounter,"descr":"Delete %s,%d"%( objType_NS[newObjType], newInstNum ) })
                self.bac_handl.t_delete_object( (newObjType, newInstNum) )
                nCounter += 1



        return 0
        # -1 => Error, epilog will fail and user will be asked, to continue or not
        #  0 => No Error, No Configuration Requirements PopUp,
        #  1 => No Error, Configuration Requirements PopUp will be shown
        #  all others states are user defined, Configuration Requirements PopUp is always shown

    #---------------------------------------------------------------------------
