# /usr/bin/python
# -*- coding: iso-8859-1 -*- 
#
#        BTF
# BacnetTestFramework
#
# Last updated: 30.01.2019
#
# Samplescript
#
# This sample script is provided to give a startpoint
# for development of BTF related scripts.
#
#
# Copyright MBS GmbH
#
#-------------------------------------------------------------------------------
from make_automation import *
#-------------------------------------------------------------------------------
class make_8_20_2(MakeAutomation):
    scriptname = '''make_8_20_2'''
    purpose = ''''''
    configreq = ''''''
    concept = ''''''

    def start(self):

        (objType, instNum), propID, index = self.private_dict['ObjPropRef']


        iut_PropFeatures = self.global_dict['IUT']['PropertyFeatures']


        if not isinstance(self.user_data, dict):
            #This Make can only be executed with the rigth user_data from the prolog
            return {}

        tr_objType = self.user_data['objType']
        tr_intNum = self.user_data['instNum']


        if self.make_dict['msg'] == 1:

            self.gcom.commit(3, {"step":0,"descr":"Starting Make for Step %d ..."%( self.make_dict['msg'] ) })

            #initiate a ReadProperty Request by enabling the TrendLog

            self.gcom.commit(3, {"step":1,"descr":"Enable Log"})
            self.bac_handl.t_write_property(tr_objType, tr_intNum, propID_SN['Enable'], 'True')


            self.gcom.commit(3, {"step":2,"descr":"Generate 1 record"})
            if not self.global_dict['IUT']['PropertyFeatures'].has_object_property(tr_objType, tr_intNum, propID_SN['Logging_Type']):
                LI = int( self.bac_handl.t_read_property(tr_objType, tr_intNum, propID_SN['Log_Interval']) )
                if LI == 0:
                    LT = logging_type_SN['cov']
                else:
                    LT = logging_type_SN['polled']
            else:
                LT = int( self.bac_handl.t_read_property(tr_objType, tr_intNum, propID_SN['Logging_Type']) )
            nCount = 1

            if LT == logging_type_SN['polled']:
                LI = int( self.bac_handl.t_read_property(tr_objType, tr_intNum, propID_SN['Log_Interval']) )
                LI /= 100
                self.gcom.commit(3, {"step":2,"substep":1,"descr":"Wait %d*Log_Interval (%d seconds)"%( nCount, nCount*LI ) })
                time.sleep( LI*nCount )

            elif LT == logging_type_SN['triggered']:
                for idx in range(0,nCount):
                    self.gcom.commit(3, {"step":2,"substep":idx,"descr":"Set Trigger"})
                    self.bac_handl.t_write_property(tr_objType, tr_intNum, propID_SN['Trigger'], 'True')
                    time.sleep( 2 )

            else:
                self.gcom.commit(6,{'description':'%s,%d has invalid LoggingType %d'%( objType_NS[tr_objType],tr_intNum, LT) })
                return {}


            time.sleep( self.global_dict['IUT']['FailTimes']['InternalProcessing'] )


            self.gcom.commit(3, {"step":3,"descr":"Disable Log"})
            self.bac_handl.t_write_property(tr_objType, tr_intNum, propID_SN['Enable'], 'False')


            return {'answer':'1'}



        elif self.make_dict['msg'] == 3:

            self.gcom.commit(3, {"step":0,"descr":"Starting Make for Step %d ..."%( self.make_dict['msg'] ) })


            self.gcom.commit(3, {"step":1,"descr":"Check Log_Buffer"})
            #check TrendLog LogBuffer for rigth value (1st:buffer-purge, 2nd:log-enable, 3rd:value)
            result = self.bac_handl.t_read_range( (tr_objType, tr_intNum), propID_SN['Log_Buffer'], BACNET_VOID_INDEX, read_range_type_SN['ByPosition'], (3, 1) )
            logBuffer = self.bac_handl.h_get_read_range_property( result )

            szValue = self.bac_handl.helper.make_list( str(logBuffer), max_level=2 )[0][1]
            #strip tag
            if szValue.startswith('['):
                szValue = szValue.split(']',1)[1].strip(' ')

            value = self.make_dict['test_data']['value']
            try:
                value.compare(szValue)
            except BacCompare, inst:
                self.gcom.commit(6,{'description':'%s'%( str(inst) ) })
                return {'answer':'0'}


            return {'answer':'1'}


        return {}
        # On Error: return -1 or raise Exception
        #       -> test will abort and fail
        #
        # On SUCCESS: return {'answer':'1'}
        #       -> test continues with success
        #
        # On FAILURE: return {'answer':'0'}
        #       -> test continues or aborts (depends on test)
        #
        # No SUCCESS or invalid Step-number: return {}
        #       -> MAKE will pop up for manual user interaction
        #

    #---------------------------------------------------------------------------
