# /usr/bin/python
# -*- coding: iso-8859-1 -*- 
#
#        BTF
# BacnetTestFramework
#
# Last updated: 30.01.2019
#
# Samplescript
#
# This sample script is provided to give a startpoint
# for development of BTF related scripts.
#
#
# Copyright MBS GmbH
#
#-------------------------------------------------------------------------------
from make_automation import *
#-------------------------------------------------------------------------------
class make_mbs_8_22_1(MakeAutomation):
    scriptname = '''make_mbs_8_22_1'''
    purpose = ''''''
    configreq = ''''''
    concept = ''''''

    def start(self):

        (objType, instNum), propID, index = self.private_dict['ObjPropRef']
        if self.private_dict['ValMustBeNull']:
            szValue = '[0]NULL'
        else:
            szValue = self.private_dict['value']

        iut_PropFeatures = self.global_dict['IUT']['PropertyFeatures']


        if not isinstance(self.user_data, dict):
            #This Make can only be executed with the rigth user_data from the prolog
            return {}


        if szValue == None:
            szValue = self.user_data['value']


        if self.make_dict['msg'] == 1 and self.make_dict['substep'] == 1:

            self.gcom.commit(3, {"step":0,"descr":"Starting Make for Step %d ..."%( self.make_dict['msg'] ) })

            #initiate a WriteProperty Request by schedule object


            self.gcom.commit(3, {"step":1,"descr":"Transmit TimeSynchronization-Request"})
            self.bac_handl.t_time_sync( "(Monday,4-February-2013),23:58:45.00" )


            self.gcom.commit(3, {"step":2,"descr":"Wait until Midnight"})
            time.sleep(75)

            self.gcom.commit(3, {"step":3,"descr":"Wait ScheduleEvaluation FailTime"})
            time.sleep( self.global_dict['IUT']['FailTimes']['ScheduleEvaluation'] )


            return {'answer':'1'}



        elif self.make_dict['msg'] == 1 and self.make_dict['substep'] == 4:

            self.gcom.commit(3, {"step":0,"descr":"Starting Make for Step %d ..."%( self.make_dict['msg'] ) })


            self.gcom.commit(3, {"step":1,"descr":"Check Value"})

            nOffset = None
            if propID == propID_SN['Local_Time']:
                nOffset = 61 #seconds, because of RTC
            elif self.bac_handl.helper.getPropertyDataType(objType, propID) == propType_SN['REAL']:
                nOffset = 0.1

            pValue = self.make_dict['test_data']['value']
            try:
                pValue.compare(szValue, off=nOffset)
            except BacCompare, inst:
                self.gcom.commit(6,{'description':'%s'%( str(inst) ) })
                return {'answer':'0'}


            return {'answer':'1'}


        return {}
        # On Error: return -1 or raise Exception
        #       -> test will abort and fail
        #
        # On SUCCESS: return {'answer':'1'}
        #       -> test continues with success
        #
        # On FAILURE: return {'answer':'0'}
        #       -> test continues or aborts (depends on test)
        #
        # No SUCCESS or invalid Step-number: return {}
        #       -> MAKE will pop up for manual user interaction
        #

    #---------------------------------------------------------------------------
