# /usr/bin/python
# -*- coding: iso-8859-1 -*- 
#
#        BTF
# BacnetTestFramework
#
# Last updated: 30.01.2019
#
# Samplescript
#
# This sample script is provided to give a startpoint
# for development of BTF related scripts.
#
#
# Copyright MBS GmbH
#
#-------------------------------------------------------------------------------
from prolog import *
#-------------------------------------------------------------------------------
class prolog_8_22_6(BasisProlog):
    scriptname = '''prolog_8_22_6'''
    purpose = ''''''
    configreq = ''''''
    concept = ''''''

    def start(self):

        (objType, instNum), propID, index = self.private_dict['ObjPropRef']
        szValue = self.private_dict['value']


        td_propFeatures = self.global_dict['TD']['PropertyFeatures']
        iut_PropFeatures = self.global_dict['IUT']['PropertyFeatures']


        self.gcom.commit(3, {"step":0,"descr":"Starting Prolog for %s,%d"%( objType_NS[objType],instNum )})

        if szValue == None:
#            pValue = self.bac_handl.h_get_td_property(objType, instNum, propID, index)
#            szInitValue = pValue.get_string( print_tags=True )
#            szValue = self.bac_handl.h_get_another_value(objType, instNum, propID, szInitValue, td_propFeatures)
            szValue = '3'
        else:
#            #change td property before receiving WriteProperty Request
#            szInitValue = self.bac_handl.h_get_another_value(objType, instNum, propID, szValue, td_propFeatures)
#            self.bac_handl.h_set_td_property(objType, instNum, propID, szInitValue, index)
            pass


        #use Schedule for DS-WP-A
        schedule_instNums = sorted( iut_PropFeatures.get_all_instNum_of_objType(objType_SN['schedule']) )
        if len(schedule_instNums) == 0:
            self.gcom.commit(6,{'description':'IUT does not have Schedule objects' })
            return -1

        sc_objType = objType_SN['schedule']
        sc_intNum = schedule_instNums[0]


        self.user_data = {}
        self.user_data['objType'] = sc_objType
        self.user_data['instNum'] = sc_intNum
        self.user_data['value'] = szValue


        self.gcom.commit(3, {"step":1,"descr":"Enable WriteProperty in TD"})
        self.bac_handl.h_set_td_services_supported_bit( services_supported_bit_SN['writeProperty'], True )
        self.bac_handl.h_set_td_services_supported_bit( services_supported_bit_SN['writePropertyMultiple'], False )


        self.gcom.commit(3, {"step":1,"substep":2,"descr":"Make property writeable"})
        self.bac_handl.h_set_td_property_access_right(objType, instNum, propID, True)


        self.gcom.commit(3, {"step":2,"descr":"Set Effective_Period"})
        self.bac_handl.t_write_property(sc_objType, sc_intNum, propID_SN['Effective_Period'], '((*,*-*-*),(*,*-*-*))')


        self.gcom.commit(3, {"step":3,"descr":"Set List_Of_Object_Property_References"})

        #everything must be deleted, before the reference can be changed
        self.gcom.commit(3, {"step":3,"substep":1,"descr":"Clear Weekly_Schedule"})
        self.bac_handl.t_write_property(sc_objType, sc_intNum, propID_SN['Weekly_Schedule'], '((),(),(),(),(),(),())')
        if iut_PropFeatures.is_writeable( sc_objType, sc_intNum, propID_SN['Exception_Schedule'] ):
            self.gcom.commit(3, {"step":3,"substep":2,"descr":"Clear Exception_Schedule"})
            self.bac_handl.t_write_property(sc_objType, sc_intNum, propID_SN['Exception_Schedule'], '()')
        self.gcom.commit(3, {"step":3,"substep":3,"descr":"Set Schedule_Default to NULL"})
        self.bac_handl.t_write_property(sc_objType, sc_intNum, propID_SN['Schedule_Default'], '[0]NULL')
        self.gcom.commit(3, {"step":3,"substep":3,"descr":"Clear List_Of_Object_Property_References"})
        self.bac_handl.t_write_property(sc_objType, sc_intNum, propID_SN['List_Of_Object_Property_References'], '()')

#        szObjPropRef = '(((%d,%d),%d,-,(%d,%d)))'%( objType,instNum, propID, objType_SN['device'],self.bac_handl.h_get_testdev_inst() )
        szObjPropRef = '(((%d,%d),%d,0,(%d,%d)))'%( objType,instNum, propID, objType_SN['device'],self.bac_handl.h_get_testdev_inst() )
        self.bac_handl.t_write_property(sc_objType, sc_intNum, propID_SN['List_Of_Object_Property_References'], szObjPropRef)


        self.gcom.commit(3, {"step":4,"descr":"Set Weekly_Schedule"})
        szWeekly = '('
        szWeekly += '((00:00:00.00,%s)),'%( szValue )
        szWeekly += '((00:00:00.00,%s)),'%( szValue )
        szWeekly += '((00:00:00.00,%s)),'%( szValue )
        szWeekly += '((00:00:00.00,%s)),'%( szValue )
        szWeekly += '((00:00:00.00,%s)),'%( szValue )
        szWeekly += '((00:00:00.00,%s)),'%( szValue )
        szWeekly += '((00:00:00.00,%s))'%( szValue )
        szWeekly += ')'
        self.bac_handl.t_write_property(sc_objType, sc_intNum, propID_SN['Weekly_Schedule'], szWeekly)


        self.gcom.commit(3, {"step":5,"descr":"Set Exception_Schedule"})
        szException = '()'
        if iut_PropFeatures.is_writeable( sc_objType, sc_intNum, propID_SN['Exception_Schedule'] ):
            self.bac_handl.t_write_property(sc_objType, sc_intNum, propID_SN['Exception_Schedule'], szException)


        self.gcom.commit(3, {"step":6,"descr":"Set Schedule_Default"})
        self.bac_handl.t_write_property(sc_objType, sc_intNum, propID_SN['Schedule_Default'], '[0]NULL')


        self.gcom.commit(3, {"step":7,"descr":"Set Priority_For_Writing"})
        self.bac_handl.t_write_property(sc_objType, sc_intNum, propID_SN['Priority_For_Writing'], 8)


        #self.gcom.commit(3, {"step":8,"descr":"Wait Schedule Evaluation FailTime"})
        #time.sleep( self.global_dict['IUT']['FailTimes']['ScheduleEvaluation'] )




        # -1 => Error, prolog will fail and user will be asked, to continue or not
        #  0 => No Error, No Configuration Requirements PopUp,
        #  1 => No Error, Configuration Requirements PopUp will be shown
        #  all others states are user defined, Configuration Requirements PopUp is always shown
        return 0
    #------------------