# /usr/bin/python
# -*- coding: iso-8859-1 -*- 
#
#        BTF
# BacnetTestFramework
#
# Last updated: 30.01.2019
#
# Samplescript
#
# This sample script is provided to give a startpoint
# for development of BTF related scripts.
#
#
# Copyright MBS GmbH
#
#-------------------------------------------------------------------------------
from prolog import *
#-------------------------------------------------------------------------------
class prolog_mbs_8_18_1(BasisProlog):
    scriptname = '''prolog_mbs_8_18_1'''
    purpose = ''''''
    configreq = ''''''
    concept = ''''''

    def start(self):

        (objType, instNum), propID, index = self.private_dict['ObjPropRef']


        iut_PropFeatures = self.global_dict['IUT']['PropertyFeatures']


        self.gcom.commit(3, {"step":0,"descr":"Starting Prolog for %s,%d"%( objType_NS[objType],instNum )})

        #use TrendLog for DS-RP-A
        trendlog_instNums = iut_PropFeatures.get_all_instNum_of_objType(objType_SN['trend-log'])
        if len(trendlog_instNums) == 0:
            self.gcom.commit(6,{'description':'IUT does not have Trend-Log objects' })
            return -1


        tr_objType = objType_SN['trend-log']
        tr_intNum = trendlog_instNums[0]

        self.user_data = {}
        self.user_data['objType'] = tr_objType
        self.user_data['instNum'] = tr_intNum


        self.gcom.commit(3, {"step":1,"descr":"Disable ReadPropertyMultiple and SubscribeCOV in TD"})
        self.bac_handl.h_set_td_services_supported_bit( services_supported_bit_SN['readProperty'], True )
        self.bac_handl.h_set_td_services_supported_bit( services_supported_bit_SN['readPropertyMultiple'], False )
        self.bac_handl.h_set_td_services_supported_bit( services_supported_bit_SN['subscribeCOV'], False )
        self.bac_handl.h_set_td_services_supported_bit( services_supported_bit_SN['subscribeCOVProperty'], False )


        self.gcom.commit(3, {"step":2,"descr":"Disable Log"})
        self.bac_handl.t_write_property(tr_objType, tr_intNum, propID_SN['Enable'], 'False')


        self.gcom.commit(3, {"step":3,"descr":"Purge Buffer"})
        self.bac_handl.t_write_property(tr_objType, tr_intNum, propID_SN['Record_Count'], '0')


        self.gcom.commit(3, {"step":4,"descr":"Set Start_Time"})
        self.bac_handl.t_write_property(tr_objType, tr_intNum, propID_SN['Start_Time'], '((*,*-*-*),*:*:*.*)')


        self.gcom.commit(3, {"step":5,"descr":"Set Stop_Time"})
        self.bac_handl.t_write_property(tr_objType, tr_intNum, propID_SN['Stop_Time'], '((*,*-*-*),*:*:*.*)')


        self.gcom.commit(3, {"step":6,"descr":"Set Stop_When_Full to False"})
        if self.global_dict['IUT']['PropertyFeatures'].is_writeable(tr_objType, tr_intNum, propID_SN['Stop_When_Full']):
            self.bac_handl.t_write_property(tr_objType, tr_intNum, propID_SN['Stop_When_Full'], 'False')


        if self.global_dict['IUT']['PropertyFeatures'].has_object_property(tr_objType, tr_intNum, propID_SN['Logging_Type']) \
        and self.global_dict['IUT']['PropertyFeatures'].is_writeable(tr_objType, tr_intNum, propID_SN['Logging_Type']):
            self.gcom.commit(3, {"step":7,"descr":"Set Logging_Type to Polled"})
            self.bac_handl.t_write_property(tr_objType, tr_intNum, propID_SN['Logging_Type'], '0')


        self.gcom.commit(3, {"step":8,"descr":"Set Log_Interval to 500"})
        self.bac_handl.t_write_property(tr_objType, tr_intNum, propID_SN['Log_Interval'], '500')


        self.gcom.commit(3, {"step":9,"descr":"Set Log_DeviceObjectProperty"})
        #set external REAL reference
        szObjectPropertyReference = '((%d,%d),%d,-,(8,%d))'%( objType,instNum, propID, self.bac_handl.h_get_testdev_inst() )
        self.bac_handl.t_write_property(tr_objType, tr_intNum, propID_SN['Log_DeviceObjectProperty'], szObjectPropertyReference)




        # -1 => Error, prolog will fail and user will be asked, to continue or not
        #  0 => No Error, No Configuration Requirements PopUp,
        #  1 => No Error, Configuration Requirements PopUp will be shown
        #  all others states are user defined, Configuration Requirements PopUp is always shown
        return 0
    #------------------