# /usr/bin/python
# -*- coding: iso-8859-1 -*- 
#
#        BTF
# BacnetTestFramework
#
# Last updated: 30.01.2019
#
# Samplescript
#
# This sample script is provided to give a startpoint
# for development of BTF related scripts.
#
#
# Copyright MBS GmbH
#
#-------------------------------------------------------------------------------
from prolog import *
#-------------------------------------------------------------------------------
class prolog_mbs_9_15_1_1(BasisProlog):
    scriptname = '''prolog_mbs_9_15_1_1'''
    purpose = ''''''
    configreq = ''''''
    concept = ''''''

    def start(self):

        (objType, instNum), propID, index = self.private_dict['ObjPropRef']

        self.gcom.commit(3, {"step":0,"descr":"Starting Prolog for %s,%d %s"%( objType_NS[objType], instNum, propID_NS[propID] ) })

        validvalues = self.global_dict['IUT']['PropertyFeatures'][(objType,instNum,propID)]['ValidValues']
        for value in validvalues:
            vList = self.bac_handl.helper.make_list( value )
            if len(vList) > 0:
                initialValue = value
                break
        else:
            self.gcom.commit(6,{'description':'Could not find an initial value with at least 1 entry'})
            return 1

        self.gcom.commit(3, {"step":1,"descr":"Set initial value %s"%initialValue })
        self.bac_handl.t_write_property(objType, instNum, propID, initialValue)



        # -1 => Error, prolog will fail and user will be asked, to continue or not
        #  0 => No Error, No Configuration Requirements PopUp,
        #  1 => No Error, Configuration Requirements PopUp will be shown
        #  all others states are user defined, Configuration Requirements PopUp is always shown
        return 0
    #------------------